/*
 * ldfs_list.h
 *
 *  Created on: 16 Aug 2011
 *      Author: ngchunho
 */

#ifndef LDFS_LIST_H_
#define LDFS_LIST_H_

struct slist_head {
	struct slist_head * next;
};

static inline void slist_head_init(struct slist_head * list) {
	list->next = list;
}

static inline void slist_add(struct slist_head * new, struct slist_head * head) {
	new->next = head->next;
	head->next = new;
}

static inline void slist_add_tail(struct slist_head * new, struct slist_head * head) {
	struct slist_head * prev = head;
	while(prev->next) {
		prev = prev->next;
	}
	prev->next = new;
	new->next = head;
}

static inline void slist_del(struct slist_head * del, struct slist_head * head) {
	struct slist_head * prev = head;
	while(prev->next !=  del) {
		prev = prev->next;
	}
	prev->next = del->next;
	del->next = NULL;
}

static inline void slist_del_first(struct slist_head * head) {
	head->next = head->next->next;
}

static inline int slist_empty(struct slist_head * head) {
	return (head->next == head);
}

static inline int slist_singular(struct slist_head * head) {
	return (head->next != head && head->next->next == head);
}

#define slist_entry(ptr, type, member) container_of(ptr, type, member)
#define slist_first_entry(ptr, type, member) list_entry((ptr)->next, type, member)

#define slist_for_each(pos, head) for (pos = (head)->next; prefetch(pos->next), pos != head; pos = pos->next)

#endif /* LDFS_LIST_H_ */
